#!/bin/sh
#
#	flactime - calculate TIME for FLAC files
#
# TODO: incorporate into sftime utility (or just bag this and use shntool)

if [ "${1:-}" = "-s" ]; then		# summary time
  sum=TRUE
  shift
fi

echo -e "hh:mm:ss \t filename"
echo -e "-------- \t --------"

flacfiles=${*:-*.flac}
let total_seconds=0

for flacfile in $flacfiles
do
  case $(uname) in
    CYGWIN*) flacfile=$(cygpath $flacfile) # get rid of any DOS colon in path
  esac

  if [ "$(file $flacfile | cut -d: -f2 | awk '{print $1}')" = "FLAC" ]; then
    sample_rate=$(  metaflac --show-sample-rate   $flacfile | sed 's/\r//' ) 
    channels=$(     metaflac --show-channels      $flacfile | sed 's/\r//' )
    total_samples=$(metaflac --show-total-samples $flacfile | sed 's/\r//' )
    
    seconds=$(( total_samples/sample_rate ))
    if [ $channels -eq 1 ]; then seconds=$(( seconds*2 )); fi
  
    total_seconds=$(( total_seconds+seconds ))
  
    hh=$(( seconds/60/60 ))
    mm=$(( (seconds - (hh*60*60)) / 60 ))
    ss=$(( seconds - hh*60*60 - mm*60 ))
  
    if [ $hh -lt 10 ]; then hh=0$hh; fi
    if [ $mm -lt 10 ]; then mm=0$mm; fi
    if [ $ss -lt 10 ]; then ss=0$ss; fi
  
    echo -e "$hh:$mm:$ss \t $flacfile"
  fi
done
  
if [ $total_seconds -ne 0 ]; then
  # decided to always give sum time
  #if [ "$sum" = "TRUE" ]; then
    hh=$(( total_seconds/60/60 ))
    mm=$(( (total_seconds - (hh*60*60)) / 60 ))
    ss=$(( total_seconds - hh*60*60 - mm*60 ))
    
    if [ $hh -lt 10 ]; then hh=0$hh; fi
    if [ $mm -lt 10 ]; then mm=0$mm; fi
    if [ $ss -lt 10 ]; then ss=0$ss; fi
    
    echo -e "-------- \t --------"
    echo -e "$hh:$mm:$ss \t total"
  #fi
fi